//+------------------------------------------------------------------+
//|                                      HistoryLevelsCreate_1.1.mq4 |
//|                                          Copyright  2010, Drknn |
//|                                                    drknn@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Drknn"
#property link      "drknn@mail.ru"
#include <Errors.mqh>
#property show_inputs
// -----------   ---------------------------
extern int			HowManyLevels=9;//       
extern string   c8="------   ------";
extern string   s="6E";
extern color    Color_Lines=Aqua;//  
extern int    	Width_Lines=3;//  
extern color    Color_Start_Zone=DodgerBlue;
extern color    Color_Other_Zone=Blue;


//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start(){
	// ---------   --------------------
	string		FileName,FileHistoryName,FileTodayName,Stroka,s_TempDate;
	int				FileHandl,FileHistoryHandl,FileTodayHandl;
	datetime	HistDateTimeStarta[1],HistDateTimeEnd[1];
	datetime	dt_Starta;
	double		HistPriceLevel[1],HistWideBufZone[1];
	// ----------   -----------------------------
	string    SMB,NameScript="HistoryLevelsCreate_1.1",NameLine,NameZone;
	double		PR_Up,PR_Down;
	int				GLE,SchStrokInFile;
	
	datetime	Time_D0=0;
	
	
	SMB=Symbol();
	Time_D0=iTime(SMB,PERIOD_D1,0);
	// -------------    -----------------------
	FileName=s+".txt";//  
	FileTodayName=s+"_Today.txt";//  
	FileHistoryName=s+"_History.txt";//  
	SchStrokInFile=SchFileStrok(FileName);
  
	// -----------    -----------------------
	if(ArrayResize(HistDateTimeStarta,SchStrokInFile+1)==(-1)){
		Alert("     HistDateTimeStarta[] -   ");
		Alert(" ============== ",NameScript," ============== ");
		return(0);
	}
	if(ArrayResize(HistDateTimeEnd,SchStrokInFile+1)==(-1)){
		Alert("     HistDateTimeEnd[] -   ");
		Alert(" ============== ",NameScript," ============== ");
		return(0);
	}
	if(ArrayResize(HistPriceLevel,SchStrokInFile+1)==(-1)){
		Alert("     HistPriceLevel[] -   ");
		Alert(" ============== ",NameScript," ============== ");
		return(0);
	}
	if(ArrayResize(HistWideBufZone,SchStrokInFile+1)==(-1)){
		Alert("     HistWideBufZone[] -   ");
		Alert(" ============== ",NameScript," ============== ");
		return(0);
	}
	FileHandl=FileOpen(FileName, FILE_CSV|FILE_READ,";");
  if(FileHandl<0){
    GLE=GetLastError();
    if(GLE==4103){
      Alert("  4103!  ",FileName,"  .");
			Alert(" ============== ",NameScript," ============== ");
      return(0);
    }
    else{
      Alert("  ",GLE,"    ",FileName);
      Alert(" ============== ",NameScript," ============== ");
			return(0);
    }
  }
	
	for(int i=1;i<=SchStrokInFile;i++){
		s_TempDate=FileReadString(FileHandl);//  
		Stroka=s_TempDate+" "+FileReadString(FileHandl);//  +  
		dt_Starta=StrToTime(Stroka);
		if(dt_Starta>=Time_D0){//    -    
			while(!FileIsLineEnding(FileHandl)){
				Stroka=FileReadString(FileHandl);
			}
			continue;
		}
		HistDateTimeStarta[i]=dt_Starta;
		//Print("HistDateTimeStarta[",i,"] = ",HistDateTimeStarta[i]);
		Stroka=s_TempDate+" "+FileReadString(FileHandl);//  +  
		HistDateTimeEnd[i]=StrToTime(Stroka);
		Stroka=FileReadString(FileHandl);//  
		HistPriceLevel[i]=StrToDouble(Stroka);//  
		if(HistPriceLevel[i]==0){
			Alert("!     ",i,"-   ",FileName," = ",HistPriceLevel[i]);
			Alert(" ============== ",NameScript," ============== ");
			FileClose(FileHandl);//  
			return(0);
		}
		HistPriceLevel[i]=NormalizeDouble(HistPriceLevel[i],Digits);
		Stroka=FileReadString(FileHandl);//   
		HistWideBufZone[i]=StrToDouble(Stroka);//   
		if(HistWideBufZone[i]==0){
			Alert("!     ",i,"-   ",FileName," = ",HistWideBufZone[i]);
			Alert(" ============== ",NameScript," ============== ");
			FileClose(FileHandl);//  
			return(0);
		}
		HistWideBufZone[i]=NormalizeDouble(HistWideBufZone[i],Digits);
		if(FileIsLineEnding(FileHandl)){//     
		  continue;//     
		}
		if(FileIsEnding(FileHandl)==true){   //     
			break;
		}
	}
	FileClose(FileHandl);//  
	
	// **************************************************************************************
	// ********************      ***********************
	// **************************************************************************************
	int SchStrok=0;
	for(int lev=1;lev<=SchStrokInFile;lev++){
		if(SchStrok==HowManyLevels){
			SchStrok=0;
		}
		SchStrok++;
		//   
		NameLine=SMB+"_HistoryLine_"+lev;
		if(ObjectFind(NameLine)==(-1)){//      .  .
			if(!ObjectCreate(NameLine,OBJ_TREND,0,HistDateTimeStarta[lev],HistPriceLevel[lev],HistDateTimeEnd[lev],HistPriceLevel[lev])){
				GeneralError();
				Alert("     ",NameLine);
				Alert(" ============== ",NameScript," ============== ");
			}
			else{
				if(!ObjectSet(NameLine,OBJPROP_COLOR,Color_Lines)){
					ObjectSetError();
					Alert("      ",NameLine);
					Alert(" ============== ",NameScript," ============== ");
				}
				if(!ObjectSet(NameLine,OBJPROP_WIDTH,Width_Lines)){
					ObjectSetError();
					Alert("      ",NameLine);
					Alert(" ============== ",NameScript," ============== ");
				}
				if(!ObjectSet(NameLine,OBJPROP_RAY,false)){//  
					ObjectSetError();
					Alert("       ",NameLine);
					Alert(" ============== ",NameScript," ============== ");
				}
			}
		}
		//    
		NameZone=SMB+"_HistoryZone_"+lev;
		if(ObjectFind(NameZone)==(-1)){//      .  .
			PR_Up=HistPriceLevel[lev]+HistWideBufZone[lev];
			PR_Down=HistPriceLevel[lev]-HistWideBufZone[lev];
			if(!ObjectCreate(NameZone,OBJ_RECTANGLE,0,HistDateTimeStarta[lev],PR_Down,HistDateTimeEnd[lev],PR_Up)){
				GeneralError();
				Print("     ",NameZone);
				Alert(" ============== ",NameScript," ============== ");
			}
			else{
				if(SchStrok==1){ //  
					if(!ObjectSet(NameZone,OBJPROP_COLOR,Color_Start_Zone)){
						GeneralError();
						Print("      ",NameZone);
						Alert(" ============== ",NameScript," ============== ");
					}
				}
				else{
					if(!ObjectSet(NameZone,OBJPROP_COLOR,Color_Other_Zone)){
						GeneralError();
						Print("      ",NameZone);
						Alert(" ============== ",NameScript," ============== ");
					}
				}
			}
		}
	}
	return(0);
}
//+-------------------------------------------------------------------
// -------------   -----------------------
//+-------------------------------------------------------------------



// ------------------ SchFileStrok(string FN) ------------------------------------------------------
//      
// :
//		string FN -  
// ---------------------------------------------------------
int SchFileStrok(string FN){
	int			SchFileStrok=0;
	int			FileHandl=(-1);
	int     GLE;
	string	Str,NameFunction="SchFileStrok()";
	FileHandl=FileOpen(FN,FILE_CSV|FILE_READ,";");
  if(FileHandl<0){
    GLE=GetLastError();
    if(GLE==4103){
      Alert("  4103!  ",FN,"  .");
			Alert(" ============== ",NameFunction," ============== ");
			return(0);
    }
    else{
      Alert("  ",GLE,"    ",FN);
			Alert(" ============== ",NameFunction," ============== ");
			return(0);
    }
  }
	else{
		Str="";
		while(!FileIsEnding(FileHandl)){//   ,       
			if(Str==""){
				Str=Str+FileReadString(FileHandl);//     
			}
			else{
				Str=Str+";"+FileReadString(FileHandl);//     
			}
			if(FileIsLineEnding(FileHandl)){//     
				SchFileStrok++;
				Str="";
				continue;//     
			}
			if(FileIsEnding(FileHandl)){   //     
				SchFileStrok++;
				break;
			}
		}
	}
	FileClose(FileHandl);//  
	return(SchFileStrok);
}